package com.iona.fuse.demo.logisticx.web.customer.client.customer;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.core.client.GWT;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.model.Order;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.model.OrderStatus;

/**
 * The service interface we use to place an Order to the OrderService.
 */
public interface AjaxOrderService extends RemoteService {
    /**
     * Utility/Convenience class.
     * Use AjaxOrderService.App.getInstance() to access static instance of OrderServiceAsync
     */
    public static class App {
        private static AjaxOrderServiceAsync ourInstance = null;

        public static synchronized AjaxOrderServiceAsync getInstance() {
            if (ourInstance == null) {
                ourInstance = (AjaxOrderServiceAsync)GWT.create(AjaxOrderService.class);
                ((ServiceDefTarget) ourInstance).setServiceEntryPoint(
                    GWT.getModuleBaseURL() + "AjaxOrderService");
            }
            return ourInstance;
        }
    }

    public OrderStatus doSubmit(Order order);
}
