package com.iona.fuse.demo.logisticx.web.customer.client.customer;
/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

/*
 * Copyright 2007 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.ChangeListener;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.Grid;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.PushButton;
import com.google.gwt.user.client.ui.ScrollPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

import com.iona.fuse.demo.logisticx.web.customer.client.Logisticx;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.model.LineItem;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.model.Order;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.model.OrderStatus;

public class CustomerView extends Composite {

    VerticalPanel mainPanel = new VerticalPanel();
    private Grid orderGrid = new Grid(6, 4);
    private Grid customerGrid = new Grid(2, 4);

    private FieldSetPanel customerFieldSet = new FieldSetPanel();
    private FieldSetPanel orderFieldSet = new FieldSetPanel();

    private ScrollPanel scroller = new ScrollPanel(mainPanel);
    private PushButton submitButton = new PushButton("Submit Order");

    private final AjaxOrderServiceAsync orderService = AjaxOrderService.App.getInstance(); 

    private Label lblCustomerId = new Label("Customer ID:");
    private TextBox txtCustomerId = new TextBox();
    private Label lblCustomerPo = new Label("Customer PO#:");
    private TextBox txtCustomerPo = new TextBox();

    private TextBox txtItemId = new TextBox();
    private Label lblItemId = new Label("Product ID: ");
    private ListBox listItemDescription = new ListBox();
    private Label lblItemDescription = new Label("Product Description: ");
    private ListBox listItemQty = new ListBox();
    private Label lblItemQty = new Label("Product Qty: ");
    private String products[] = {"Fuse Video Game System", "Fuse Laptop EAA300", "Fuse Mobile LKK20", "Fuse MP3 Player", "Fuse GPS", "Fuse Camera 500L", "Fuse Video Recorder 1000X", "Fuse PC D920", "Fuse Flat Screen TV42", "Fuse Sound System 700B"};  

    public CustomerView() {
        orderFieldSet.setCaption("Order Detail");
        orderFieldSet.add(orderGrid);
        customerFieldSet.setCaption("Customer Information");
        customerFieldSet.add(customerGrid);

        int row = 0;
        customerGrid.setWidget(row, 0, lblCustomerId);
        customerGrid.setWidget(row, 1, txtCustomerId);

        customerGrid.setWidget(row, 2, lblCustomerPo);
        customerGrid.setWidget(row, 3, txtCustomerPo);
        
        for (int i = 0; i < products.length; i++) {
            listItemDescription.addItem(products[i]);
        }
        listItemDescription.setVisibleItemCount(1);
                
        orderGrid.setWidget(++row, 0, lblItemDescription);
        orderGrid.setWidget(row, 1, listItemDescription);
        listItemDescription.addChangeListener(new ChangeListener() {
             public void onChange(Widget item) {
                     String productId = "100" + listItemDescription.getSelectedIndex();
                     txtItemId.setReadOnly(false);
                     txtItemId.setText(productId);
                     txtItemId.setReadOnly(true);
             }
        });
        

        txtItemId.setText("1000");
        txtItemId.setReadOnly(true);
        orderGrid.setWidget(++row, 0, lblItemId);
        orderGrid.setWidget(row, 1, txtItemId);
        
        for (int i = 0; i < 20; i++) {
            listItemQty.addItem(Integer.toString(i+1));
        }
        listItemQty.setSelectedIndex(0);
        orderGrid.setWidget(++row, 0, lblItemQty);
        orderGrid.setWidget(row, 1, listItemQty);
        
        orderGrid.setWidget(++row, 2, submitButton);

        // Add a ClickListener which will take the user's input and
        // perform an asynchronous call to the server side AjaxOrderService
        // when the button is clicked.
        submitButton.addClickListener(new ClickListener() {
            public boolean isValidId(String str) {
                try {
                    Long.parseLong(str);
                    return true;
                } catch (NumberFormatException ex) {
                    return false;
                }
            }
            public void onClick(Widget widget) {
                try {
                    Order order = new Order();
            
                    String customerId = txtCustomerId.getText();
                    if (!isValidId(customerId)) {
                        Window.alert("Customer id is not a valid id number.");
                        return;
                    }
                    order.setCustomerId(Long.parseLong(customerId));
                    // TODO: Do something about parsing valid input.
                    order.setCustomerPoNumber(txtCustomerPo.getText());

                    // TODO: This needs to be a dynamic list so we can add/delete items
                    String itemId = txtItemId.getText();
                    if (!isValidId(itemId)) {
                        Window.alert("Item id is not a valid id number.");
                        return;
                    }
                    LineItem item = new LineItem();
                    item.setItemId(Long.parseLong(itemId));
                    item.setDescription(listItemDescription.getItemText(listItemDescription.getSelectedIndex())) ;
                    item.setQuantity(Integer.parseInt(listItemQty.getItemText(
                        listItemQty.getSelectedIndex())));

                    order.setLineItem(item);

                    orderService.doSubmit(order, new AsyncCallback() {
                        public void onSuccess(Object result) {
                            OrderStatus status = (OrderStatus) result;
                            Logisticx.get().addStatusMessage(status);
                        }

                        public void onFailure(Throwable caught) {
                            Window.alert("AjaxOrderService Failed: " + caught);
                        }
                    });
                } catch (Exception ex) {
                    Window.alert("Failed to call OrderService : " + ex);
                }
            }
        });

        // Associate the CSS order-Detail style defined in
        // public/Logisticx.css with the customer and order field sets.
        customerFieldSet.setStyleName("order-Detail");
        orderFieldSet.setStyleName("order-Detail");

        scroller.setSize("100%", "100%");
        mainPanel.add(customerFieldSet);
        mainPanel.add(orderFieldSet);
        initWidget(mainPanel);
    }

    public void adjustSize(int windowWidth, int windowHeight) {
        int scrollWidth = windowWidth - scroller.getAbsoluteLeft() - 9;
        if (scrollWidth < 1) {
            scrollWidth = 1;
        }

        int scrollHeight = windowHeight - scroller.getAbsoluteTop() - 9;
        if (scrollHeight < 1) {
            scrollHeight = 1;
        }

        scroller.setSize("" + scrollWidth, "" + scrollHeight);
    }
}
