package com.iona.fuse.demo.logisticx.web.customer.server;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import com.iona.fuse.demo.logisticx.service.order.OrderService;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.AjaxOrderService;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.model.Order;
import com.iona.fuse.demo.logisticx.web.customer.client.customer.model.OrderStatus;
import org.apache.cxf.interceptor.LoggingOutInterceptor;
import org.apache.cxf.jaxws.JaxWsProxyFactoryBean;
import net.sf.dozer.util.mapping.DozerBeanMapperSingletonWrapper;
import net.sf.dozer.util.mapping.MapperIF;

public class AjaxOrderServiceImpl extends RemoteServiceServlet implements AjaxOrderService {

    private static final long serialVersionUID = 6435575416150538550L;
    
    transient JaxWsProxyFactoryBean factory = new JaxWsProxyFactoryBean();
    transient MapperIF mapper = DozerBeanMapperSingletonWrapper.getInstance();

    public AjaxOrderServiceImpl() {
        // Set up the JaxWsProxyFactory with our jax-ws annotated service
        // class and the target endpoint url.
        factory.getOutInterceptors().add(new LoggingOutInterceptor());
        factory.setServiceClass(OrderService.class);
        factory.setAddress("http://localhost:8192/order-service/");
    }

    public OrderStatus doSubmit(Order order) {
        OrderService client = (OrderService)factory.create();

        // Dozer maps from the gwt Order class to the cxf Order class.
        com.iona.fuse.demo.logisticx.model.Order newOrder = 
            (com.iona.fuse.demo.logisticx.model.Order)mapper.map(
                order, com.iona.fuse.demo.logisticx.model.Order.class);

        // Now we can invoke the cxf service.
        com.iona.fuse.demo.logisticx.model.OrderStatus status = client.putOrder(newOrder);

        // Finally, map from the returned cxf OrderStatus class to the gwt
        // OrderStatus class.
        OrderStatus newStatus = (OrderStatus)mapper.map(status, OrderStatus.class);

        return newStatus;
    }
}
