package com.iona.fuse.demo.logisticx.order.processor.support;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.springframework.jms.support.converter.MessageConversionException;
import org.springframework.jms.support.converter.SimpleMessageConverter;

import com.iona.fuse.demo.logisticx.model.OrderStatus;

public class OrderStatusMessageConverter extends SimpleMessageConverter {

    /**
     * Convert the fields of OrderStatus we are interested in to a TextMessage.
     */
    public Message toMessage(Object o, Session s) throws JMSException,
        MessageConversionException {
        if (o instanceof OrderStatus) {
            OrderStatus orderStatus = (OrderStatus)o;
            TextMessage message =
            s.createTextMessage(orderStatus.toXml());
            return message;
        }
        return super.toMessage(o, s);
    }
}
