package com.iona.fuse.demo.logisticx.order.persistence;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import com.iona.fuse.demo.logisticx.model.Order;
import org.apache.camel.builder.RouteBuilder;

/**
 * This Camel route accomplishes the following:
 *
 * - Exposes this route as a JBI endpoint
 * - Converts the xml content to an Order POJO using JAXB
 * - Persist the Order POJO using JPA
 * 
 */
public class PersistOrderRoute extends RouteBuilder {

    public void configure() {
        from("jbi:endpoint:http://logisticx.demo.fuse.iona.com/persistenceService/order")
                .convertBodyTo(Order.class)
                .to("jpa:com.iona.fuse.demo.logisticx.model.Order?persistenceUnit=order-processor")
                .convertBodyTo(Order.class);
    }
}
