package com.iona.fuse.demo.logisticx.service.warehouse;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import javax.jws.WebMethod;
import javax.jws.WebService;

import com.iona.fuse.demo.logisticx.model.StockItem;
import com.iona.fuse.demo.logisticx.model.Order;
import com.iona.fuse.demo.logisticx.model.OrderStatus;

/**
 * A web service offered to Logisticx Processing Service to fullfill orders. 
 * Determines if items are in stock. 
 *
 */
@WebService( targetNamespace = "http://logisticx.demo.fuse.iona.com/warehouseService/")
public interface Warehouse {

    /**
     * Used to process an Order at the warehouse service. 
     * 
     * @param order The order object being submitted by the customer
     * @return
     */
    @WebMethod
    public abstract OrderStatus inStock(Order order);

    
    /**
     * Used to update Stock count at the warehouse service. 
     * 
     * @param item - the product count that is being updated.
     * @return
     */
    @WebMethod 
    public abstract boolean updateStock(StockItem item);   

}
