package com.iona.fuse.demo.logisticx.service.warehouse;

/**
 * 
 * Copyright  2007-2008 IONA Technologies PLC.
 *           All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

import javax.xml.ws.Endpoint;

public class WarehouseServer {
	 
    private static final String address = "http://localhost:8080/warehouse/services/warehouse";

    public static void main(String[] args) {		
        // Create implementation object
        // 
        Object impl = new WarehouseImpl(); 
		
        // Publish endpoint, using the Endpoint.publish() method
        // with the address and the implementation object as
        // parameters.
        // 
        System.out.println("Publishing endpoint");
        Endpoint endpoint = Endpoint.create(impl); 
        endpoint.publish(address); 
        		
        // The endpoints are now listening for requests;
        // The main thread will complete, but the Bus 
        // threads will continue to process requests.
        //
	System.out.println("Listening for requests...");
    }
}


